
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android开发之Audio播放：竞争Audio之Audio Focus的应用 / iVAN</title>

    <meta name="description" content="Android开发之Audio播放：竞争Audio之Audio Focus的应用 Android是多任务系统,Audio系统是竞争资源.Android2.2之前,没有内建的机制来解决多个程序竞争Audio的问题,2.2引入了称作AudioFocus的机制来管理对Audio资源的竞争的管理与协调.本文主要讲解AudioFocus的使用. 按照AudioFocus的机制,在使用AudioStream之前,需要申请AudioFocus,在获得AudioFocus之后才可以使用相应的AudioStream:如果有别的程序竞争你正在使用的AudioStream,你的程序需要在收到通知之">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android开发之Audio播放：竞争Audio之Audio Focus的应用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="http://www.linuxidc.com/topicnews.aspx?tid=11" rel="external nofollow noreferrer">Android</a>是多任务系统，Audio系统是竞争资源。Android2.2之前，没有内建的机制来解决多个程序竞争Audio的问题，2.2引入了称作AudioFocus的机制来管理对Audio资源的竞争的管理与协调。本文主要讲解AudioFocus的使用。</p>
<p>按照AudioFocus的机制，在使用AudioStream之前，需要申请AudioFocus，在获得AudioFocus之后才可以使用相应的AudioStream；如果有别的程序竞争你正在使用的AudioStream，你的程序需要在收到通知之后做停止播放或者降低声音的处理。值得指出的是，这种机制是需要合作完成的，需要所有使用Audio资源的程序都按照这种机制来做，而如果有程序在它失去AudioFocus的时候仍然在使用Audio，AudioFocus拿它也没办法。而这一点对于开放系统的Android来说很致命的：用户可能安装没遵守这种机制的程序，或者版本太老还没引入这种机制的程序，这最终会导致很差的用户体验。</p>
<p>对于手机方案公司来说，要做的能做的事情就是教育和培训团队成员以保证自己内建的程序遵守机制没问题，这包括了Android原生的程序、自己开发的程序，以及适配第三方的程序。</p>
<p> </p>
<p><strong>一、AudioFocus的申请与释放</strong></p>
<p>下面看与AudioFocus的相关的类：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4aWRjLmNvbS91cGxvYWQvMjAxMl8wNC8xMjA0MDMxNDQ2ODUxNzEuanBn.jpg"></p>
<p>获取/放弃AudioFocus的方法都在android.media.AudioManager中，获取AudioFocus用<code><a href="http://developer.android.com/reference/android/media/AudioManager.html#requestAudioFocus(android.media.AudioManager.OnAudioFocusChangeListener,%20int,%20int)" rel="external nofollow noreferrer">requestAudioFocus()</a></code>；用完之后，放弃AudioFocus，用<code><a href="http://developer.android.com/reference/android/media/AudioManager.html#abandonAudioFocus(android.media.AudioManager.OnAudioFocusChangeListener)" rel="external nofollow noreferrer">abandonAudioFocus()</a></code>。</p>
<p>其中，<strong>参数</strong>：</p>
<ul>
<li> <strong>streamType</strong>是《<a href="http://www.linuxidc.com/Linux/2012-04/57903.htm" rel="external nofollow noreferrer">Android中的Audio播放：音量和远程播放控制</a>》中说明的AudioStream，其值取决于AudioManager中的STREAM_xxx；</li>
<li> <strong>durationHint</strong>是持续性的指示：
<ul>
<li><code><a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_GAIN" rel="external nofollow noreferrer">AUDIOFOCUS_GAIN</a></code>指示申请得到的Audio<br />
 Focus不知道会持续多久，一般是长期占有；</li>
<li><code><a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_GAIN_TRANSIENT" rel="external nofollow noreferrer">AUDIOFOCUS_GAIN_TRANSIENT</a></code>指示要申请的AudioFocus是暂时性的，会很快用完释放的；</li>
<li><a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_GAIN_TRANSIENT_MAY_DUCK" rel="external nofollow noreferrer">AUDIOFOCUS_GAIN_TRANSIENT_MAY_DUCK</a>不但说要申请的AudioFocus是暂时性的，还指示当前正在使用AudioFocus的可以继续播放，只是要“duck”一下（降低音量）。</li>
</ul>
</li>
<li> <strong><a href="http://developer.android.com/reference/android/media/AudioManager.OnAudioFocusChangeListener.html" rel="external nofollow noreferrer">AudioManager.OnAudioFocusChangeListener</a></strong>是申请成功之后监听AudioFocus使用情况的Listener，后续如果有别的程序要竞争AudioFocus，都是通过这个Listener的<a href="http://developer.android.com/reference/android/media/AudioManager.OnAudioFocusChangeListener.html#onAudioFocusChange(int)" rel="external nofollow noreferrer">onAudioFocusChange()</a>方法来通知这个Audio<br />
 Focus的使用者的。</li>
</ul>
<p><strong>返回值</strong>，可能是：</p>
<ul>
<li> <a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_REQUEST_GRANTED" rel="external nofollow noreferrer">AUDIOFOCUS_REQUEST_GRANTED</a>：申请成功；</li>
<li> <a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_REQUEST_FAILED" rel="external nofollow noreferrer">AUDIOFOCUS_REQUEST_FAILED</a>：申请失败。</li>
</ul>
<p><strong>二、AudioFocus被抢占与重新获得</strong></p>
<p>由上节中知道，申请/释放AudioFocus时传入了<strong><a href="http://developer.android.com/reference/android/media/AudioManager.OnAudioFocusChangeListener.html" rel="external nofollow noreferrer">AudioManager.OnAudioFocusChangeListener</a></strong>这个参数，其<a href="http://developer.android.com/reference/android/media/AudioManager.OnAudioFocusChangeListener.html#onAudioFocusChange(int)" rel="external nofollow noreferrer">onAudioFocusChange()</a>方法是Audio<br />
 Focus被抢占与再次获得通知的地方。所以，每个要使用AudioFocus的程序都要小心实现这个函数，保证AudioFocus实现的一致性。</p>
<p><a href="http://developer.android.com/reference/android/media/AudioManager.OnAudioFocusChangeListener.html#onAudioFocusChange(int)" rel="external nofollow noreferrer">onAudioFocusChange()</a>方法的focusChange参数指示了该AudioFocus的竞争者对AudioFocus的拥有情况，取值如下：</p>
<ul>
<li> <a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_GAIN" rel="external nofollow noreferrer">AUDIOFOCUS_GAIN</a>：获得了Audio Focus；</li>
<li> <a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_LOSS" rel="external nofollow noreferrer">AUDIOFOCUS_LOSS</a>：失去了Audio Focus，并将会持续很长的时间。这里因为可能会停掉很长时间，所以不仅仅要停止Audio的播放，最好直接释放掉Media资源。而因为停止播放Audio的时间会很长，如果程序因为这个原因而失去AudioFocus，最好不要让它再次自动获得AudioFocus而继续播放，不然突然冒出来的声音会让用户感觉莫名其妙，感受很不好。这里直接放弃AudioFocus，当然也不用再侦听远程播放控制【如下面代码的处理】。要再次播放，除非用户再在界面上点击开始播放，才重新初始化Media，进行播放。</li>
<li> <a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_LOSS_TRANSIENT" rel="external nofollow noreferrer">AUDIOFOCUS_LOSS_TRANSIENT</a>：暂时失去Audio Focus，并会很快再次获得。必须停止Audio的播放，但是因为可能会很快再次获得AudioFocus，这里可以不释放Media资源；</li>
<li> <code><a href="http://developer.android.com/reference/android/media/AudioManager.html#AUDIOFOCUS_LOSS_TRANSIENT_CAN_DUCK" rel="external nofollow noreferrer">AUDIOFOCUS_LOSS_TRANSIENT_CAN_DUCK</a></code>：暂时失去AudioFocus，但是可以继续播放，不过要在降低音量。</li>
</ul>
<p>下面是<a href="http://developer.android.com/reference/android/media/AudioManager.OnAudioFocusChangeListener.html#onAudioFocusChange(int)" rel="external nofollow noreferrer">onAudioFocusChange()</a>方法处理的代码片段：</p>
<pre></pre>
<p><ol>
<li>OnAudioFocusChangeListener afChangeListener = <strong>new</strong> OnAudioFocusChangeListener() {  </li>
<li>    <strong>public</strong> <strong>void</strong> onAudioFocusChange(<strong>int</strong> focusChange) {  </li>
<li>        <strong>if</strong> (focusChange == AudioManager.AUDIOFOCUS_LOSS_TRANSIENT  </li>
<li>            // Pause playback   </li>
<li>        } <strong>else</strong> <strong>if</strong> (focusChange == AudioManager.AUDIOFOCUS_LOSS) {  </li>
<li>            am.unregisterMediaButtonEventReceiver(RemoteControlReceiver);  </li>
<li>            am.abandonAudioFocus(afChangeListener);  </li>
<li>            // Stop playback   </li>
<li>        } <strong>else</strong> <strong>if</strong> (focusChange == AUDIOFOCUS_LOSS_TRANSIENT_CAN_DUCK) {  </li>
<li>            // Lower the volume   </li>
<li>        } <strong>else</strong> <strong>if</strong> (focusChange == AudioManager.AUDIOFOCUS_GAIN) {  </li>
<li>            // Resume playback or Raise it back to normal   </li>
<li>        }  </li>
<li>    }  </li>
<li>};   </li>
</ol>
<p><strong>三、典型的应用AudioFocus的场景</strong></p>
<p>下面的时序图描述了AudioFocus被抢占与再次获取的典型场景：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmxpbnV4aWRjLmNvbS91cGxvYWQvMjAxMl8wNC8xMjA0MDMxNDQ2ODUxNzIuanBn.jpg"></p>
<p><strong>Audio Focus被抢占与再次获取的时序图</strong></p>
<p><strong>注意</strong>：<em>为了描述简单，此图中除了两个竞争Audio Focus的App之外，只用AudioManager表征了Android的AudioFocus机制中内部参与的对象，实际AudioManager只是外部的表象，内部参与的对象很多，回调函数也并非简单的直接由AudioManager调用，其中还包含了复杂的IPC机制。</em></p>
<p>图中：</p>
<ul>
<li>AudioFocus Client通过requestAudioFocus()获取AudioFocus，在获得AudioFocus之后，开始播放Audio[Step#1 ~ #2]；</li>
<li>其它程序（Other App）也通过requestAudioFocus()获取同类AudioStream的AudioFocus [Step#3]</li>
<li>AudioFocus Client失去了Audio Focus，在onAudioFocusChanged()中，根据focusChange的值，做第二节中的处理[Step#4]；</li>
<li>其它程序（Other App）获取Audio Focus之后，开始播放Audio[Step#5]；</li>
<li>其它程序（Other App）使用Audio之后，通过<code><a href="http://developer.android.com/reference/android/media/AudioManager.html#abandonAudioFocus(android.media.AudioManager.OnAudioFocusChangeListener)" rel="external nofollow noreferrer">abandonAudioFocus()</a></code>归还AudioFocus<br />
 [Step#6]；</li>
<li>AudioFocus Client重新获得了Audio Focus，可做进一步的处理 [Step#7]</li>
</ul>
<p> </p>
<p><strong>小结</strong></p>
<p>Audio Focus机制要参与各方充分理解并统一遵照施行，有没有遵照者或者实现有误的程序存在就可能打破这一机制，带来糟糕的用户体验。在保证Built-in程序没问题的前提下，如果进入AndroidMarket之前的程序都严格执行了AudioFocus相关的测试，应该也没问题。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 11:19:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android开发之Audio播放：竞争Audio之Audio Focus的应用的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNjYOWM.html" rel="bookmark">Android开发之旅&colon; Intents和Intent Filters（理论部分）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 大部分移动设备平台上的应用程序都运行在他们自己的沙盒中.他们彼此之间互相隔离, 并且严格限制应用程序与硬件和原始组件之间的交互. 我们知道交流是多么的重要,作为一个孤岛没有交流的东西,一定毫无意义!Android应用程序也是一个沙盒,但是他们能够使用Intent. Broadcast Receivers.Adapters.Content Providers.Internet去突破他们的边界互相交流.有交流还会和谐,由此可见这些交流手段有多重要. 上篇文章中我们在 SMS接收程序和使用Int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRq15xb.html" rel="bookmark">Android开发之旅：android架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 通过前面两篇: Android 开发之旅:环境搭建及HelloWorld Android 开发之旅:HelloWorld项目的目录结构 我 们对android有了个大致的了解,知道如何搭建android的环境及简单地写一个HelloWorld程序,而且知道一个android项目包括哪 些文件夹和文件及相应的作用.本篇将站在顶级的高度--架构,来看android.我开篇就说了,这个系列适合0基础的人且我也是从0开始按照这个步骤来 学的,谈架构是不是有点螳臂挡车,自不量力呢?我觉得其实不然,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVNLvVz.html" rel="bookmark">Android开发之旅：应用程序基础及组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--成功属于耐得住寂寞的人,接下来几篇将讲述Android应用程序的原理及术语,可能会比较枯燥.如果能够静下心来看,相信成功将属于你. 引言 为了后面的例子做准备,本篇及接下来几篇将介绍Android应用程序的原理及术语,这些也是作为一个Android的开发人员必须要了解,且深刻理解的东西.本篇的主题如下: 1.应用程序基础 2.应用程序组件 2.1.活动(Activities) 2.2.服务(Services) 2.3.广播接收者(Broadcast receivers) 2.4.内容提供者(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYXjE5b.html" rel="bookmark">Android开发之旅：组件生命周期（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 应用程序组件有一个生命周期--一开始Android实例化他们响应意图,直到结束 实例被销毁.在这期间,他们有时候处于激活状态,有时候处于非激活状态:对于活动,对用户有时候可见,有时候不可见.组件生命周期将讨论活动.服务.广播 接收者的生命周期--包括在生命周期中他们可能的状态.通知状态改变的方法.及这些状态的组件寄宿的进程被终结和实例被销毁的可能性. 上篇Android开发之旅:组件生命周期(一)讲解了论活动的生命周期及他们可能的状态.通知状态改变的方法.本篇将介绍服务和广播接收者的生命周			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJqDPDp.html" rel="bookmark">Android开发之旅：应用程序基础及组件（续）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--成功属于耐得住寂寞的人,你离成功又近了一步了. 引言 上篇Android开发之旅:应用程序基础及组件介绍了应用程序的基础知识及Android的四个组件,本篇将介绍如何激活组关闭组件等.本文的主题如下: 1.激活组件:意图(Intents) 1.1.活动(Activity)组件的激活 1.2.服务(Service)组件的激活 1.3.广播接收者(Broadcast receiver)组件的激活 2.关闭组件 3.清单文件 4.Intent过滤器 1.激活组件:意图(Intents) 当接收到C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW7GeEM.html" rel="bookmark">Android开发之Service用法实例&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之Service用法.分享给大家供大家参考.具体分析如下: Service是一个生命周期较长而且没有界面的程序. 下面通过一个播放mp3的例子来学习. 先看MainActivity.java package com.example.servicetest; import android.app.Activity; import android.content.Intent; import android.os.Bundle; import android.view			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmlDxz.html" rel="bookmark">Android开发之Notification通知用法详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之Notification通知用法.分享给大家供大家参考,具体如下: 根据activity的生命周期,在activity不显示时,会执行onStop函数(比如按下home键),所以你在onStop函数(按退出键除外)里面把notification放在通知栏里,再此显示时,把notification从通知栏里去掉.或者,只要程序在运行就一直显示通知栏图标. 下面对Notification类中的一些常量,字段,方法简单介绍一下: 常量: DEFAULT_ALL 使用所			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYZmnb.html" rel="bookmark">Android开发之TabActivity用法实例详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之TabActivity用法.分享给大家供大家参考,具体如下: 一.简介 TabActivity继承自Activity,目的是让同一界面容纳更多的内容.TabActivity实现标签页的功能,通过导航栏对各个页面进行管理. 二.XML布局文件 注意: 1.TabActivity的布局文件要求以TabHost作为XML布局文件的根. 2.通常我们采用线性布局,所以&lt;TabHost&gt; 的子元素是 &lt;LinearLayout&gt;. 3.&lt;TabWidg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPLjaZp.html" rel="bookmark">Android开发之Notification通知用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之Notification通知用法.分享给大家供大家参考,具体如下: 根据activity的生命周期,在activity不显示时,会执行onStop函数(比如按下home键),所以你在onStop函数(按退出键除外)里面把notification放在通知栏里,再此显示时,把notification从通知栏里去掉.或者,只要程序在运行就一直显示通知栏图标. 下面对Notification类中的一些常量,字段,方法简单介绍一下: 常量: DEFAULT_ALL 使用所			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKdll5M.html" rel="bookmark">Android开发之Service用法实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之Service用法.分享给大家供大家参考.具体分析如下: Service是一个生命周期较长而且没有界面的程序. 下面通过一个播放mp3的例子来学习. 先看MainActivity.java package com.example.servicetest; import android.app.Activity; import android.content.Intent; import android.os.Bundle; import android.view			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7QXMW.html" rel="bookmark" class="title">PS为外景美女调出绿色清新初恋色调教程</a>
					<div>
						如果人生如最初般那样相遇, 那我们是否都会好好珍惜身边的... ------------------------------------原图来自网络-------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5RB6z.html" rel="bookmark" class="title">Java se 7 最新特性研究（一&rpar;</a>
					<div>
						从2006到现在等待了多年的jdk7终于发布了.这里将对它的一些新特做一些初步的研究: jdk7 相对于jdk6主要在以一几个方面有了非常显著的改进的提升: 首先分析其对java语言本身的改进: 二进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6GALp.html" rel="bookmark" class="title">酷炫的汽车仪表盘UI设计合集</a>
					<div>
						  随着智能汽车的崛起,车载智能系统的设计也成了各大厂商越来越关心的事情了.相比于手机和平板的UI设计的日新月异,目前市场上的车载仪表盘简直是上个时代的遗老.好在车企有心图变,而科技企业也觊觎着这个新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQJ4KM.html" rel="bookmark" class="title">数据库操作类&lpar;可用于任意数据库&rpar;</a>
					<div>
						数据|数据库 前些日子无聊写的一个类,针对于不同的数据库来写的.现在还是不能说是完整的,因为还有很多功能都没有写完全.同样,在下面的代码当中也只可用于SQL和OLE两种,对于Oracle.MySql等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxAQob.html" rel="bookmark" class="title">python的web简单示例</a>
					<div>
						比如你抽取右边的活动 代码段如下: import re #正则类 from urllib import urlopen #提取内容类 #打开链接 webpage = urlopen(&quot;htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNl0vb.html" rel="bookmark" class="title">&lbrack;AS功能代码教程12&rsqb; 填色游戏</a>
					<div>
						在本次课程中我们将学习使用Color类来制作一个填色游戏 并通过本实例复习for...in及SharedObject的应用 思路: 1.使用脚本代码创建一个调色盘,鼠标点击色块后进行取色; 2.绘制作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8j02ob.html" rel="bookmark" class="title">XPS文档阅读器</a>
					<div>
						XPS是微软的一个文档标准,就像Adobe的PDF,现在网上也有很多的PDF文档在线阅读器,而XPS文档阅读器很少几乎没有.今天我将我制作的这个XPS文档阅读器拿出来跟大家分享,也顺便期望某个高手能解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PdJDM.html" rel="bookmark" class="title">Office 2010安装出错怎么办？</a>
					<div>
						  Office 2010安装出错怎么办?下面,就和小编一起来看看吧. Office 2010 解决办法一 1.打开开始菜单,选择&quot;运行&quot;,或者按快捷键:win+r 2.输入&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxe0ob.html" rel="bookmark" class="title">word文档中如何插入不常见的符号</a>
					<div>
						  word文档中如何插入不常见的符号          方法1 打开word文档,依次点击&quot;插入&quot;--&quot;符号&quot;--&quot;其他符号&quot;. 2.在弹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPGdwz.html" rel="bookmark" class="title">智能abc输入法经验浅谈二</a>
					<div>
						2.特别好用的是,如果你想输入&quot;的&quot;,直接输入&quot;d&quot;,会比输入&quot;de&quot;更方便.如果你想输入&quot;是&quot;,直接输入&quot;s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLk5Kb.html" rel="bookmark" class="title">python基于xmlrpc实现二进制文件传输的方法</a>
					<div>
						  本文实例讲述了python基于xmlrpc实现二进制文件传输的方法.分享给大家供大家参考.具体实现方法如下: 服务器端: ? 1 2 3 4 5 6 7 8 9 10 from SimpleXML ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLL7mb.html" rel="bookmark" class="title">在Word2010文档中设置剪贴画柔化边缘效果</a>
					<div>
						  借助Word2010提供的剪贴画柔化边缘功能,用户可以为Word2010文档中的剪贴画设置柔化边缘效果,使剪贴画的边缘呈现比较模糊的效果,操作步骤如下所述: 第1步,打开Word2010文档窗口, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNQD8M.html" rel="bookmark" class="title">去哪儿网怎么解绑银行卡</a>
					<div>
						  去哪儿网怎么解绑银行卡?很多喜欢出行前在去哪儿网预定酒店和机票,进行交易时,我们都需要利用网上银行卡支付.与此同时,银行卡信息会自动绑定在去哪儿网账户上.如果银行卡换了,或者出于保密或其他原因,想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwBWDb.html" rel="bookmark" class="title">最近流行的数据库挂马的解决方法</a>
					<div>
						前段时间,公司一个主要的http://www.aliyun.com/zixun/aggregation/8613.html&quot;&gt;网站数据库中个别表的数据经常被修改并挂马,由 于网站是以前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7w2Bb.html" rel="bookmark" class="title">正当虚拟货币比特币身价狂飙、交易价突破1000美元之际</a>
					<div>
						据英国&lt;每日邮报&gt;报道,正当虚拟货币比特币身价狂飙.交易价突破1000美元之际,英国一名男子却在追悔莫及,因为几个月前他把一个存有7500个比特币的&quot;脏硬盘&quot;扔入了垃圾 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPdqrp.html" rel="bookmark" class="title">bootstrap datatable 用jquery取列的值</a>
					<div>
						问题描述 bootstrap datatable 用jquery取列的值 需求: ajax 请求java 后台返回一个list 结果集,然后用bootstrap datatable 做展示,然后点击行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP9glp.html" rel="bookmark" class="title">《Adobe Illustrator CS5中文版经典教程》目录&mdash;导读</a>
					<div>
						版权声明 Adobe Illustrator CS5中文版经典教程 Authorized translation from the English language edition, entitled ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE3Lmz.html" rel="bookmark" class="title">ios-iOS uiwebview使用html5出现崩溃并且无法定位</a>
					<div>
						问题描述 iOS uiwebview使用html5出现崩溃并且无法定位 // // WebUrlLoadViewController.m // ChatDemo-UI2.0 // // Created ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRo5Vb.html" rel="bookmark" class="title">PS笔刷安装技巧</a>
					<div>
						  PS笔刷安装技巧 1.首先要知道,PS的笔刷后辍名统一为*.abr. 2.安装方法: Photoshop 8.0以上版本安装路径为:打开安装PS的文件夹--预置--画笔--将你下载的笔刷解压到这里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pke0j1b.html" rel="bookmark" class="title">《变形金刚OL》预定明年在中韩两国率先推出</a>
					<div>
						孩之宝与中国大陆游戏厂商网龙网络合作研发.以&lt;变形金刚&gt;为主题的新款在线游戏&lt;变形金刚 Online&gt;计划先在中国大陆与韩国推出. 拥有&lt;变形金刚&gt; 版权的孩之宝营 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWXEkz.html" rel="bookmark" class="title">android 登录获取好友列表</a>
					<div>
						问题描述 每次登录自己的程序后在登录环信,然后进入的话是没有好友列表的,只有退出登录后,在登录环信才有数据,这是怎么回事??在线等 解决方案 那你要看有没有执行获取的方法解决方案二:&gt; foru ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlG2np.html" rel="bookmark" class="title">苹果App Store调整排名规则打击APP刷排名行为</a>
					<div>
						[赛迪网讯]3月30日消息,据iOS开发者爆料,自3月24日起,苹果App Store调整了排名规则,打击APP刷排名行为.App Store中国区免费榜TOP300榜单中,有50多个APP排名出现明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZJEYM.html" rel="bookmark" class="title">安装logstash&comma;elasticsearch&comma;kibana三件套</a>
					<div>
						logstash,elasticsearch,kibana三件套 elk是指logstash,elasticsearch,kibana三件套,这三件套可以组成日志分析和监控工具 注意: 关于安装文档, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRg88b.html" rel="bookmark" class="title">关于SourceForge不能使用的问题</a>
					<div>
						sourceforge SourceForge.net,又称SF.net,是开源软件开发者进行开发管理的集中式场所,也是全球最大开源软件开发平台和仓库. SourceForge.net由VA Soft ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0WXQM.html" rel="bookmark" class="title">网站产品设计需谨慎 避开七大误区</a>
					<div>
						对于网站设计来说,存在很多误区,对于网站的建设者来说,如果没有起到吸引用户的作用,犯了下面的问题,带来的损失可能会令你欲哭无泪.避免下列设计误区,可以事半功倍. 求大求全而不求精.弗吉尼亚州罗浮市Gr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J9dmz.html" rel="bookmark" class="title">张锐表示：开放化是轻博客有别于传统博客的最大特点之一</a>
					<div>
						点点网联合创始人兼产品运营负责人张锐近日在专访中强调开放化是轻博客有别于传统博客的最大特点之一.张锐透露点点网完全开放html的自定义,用户可以在自己的轻博客上挂广告或挂自己想挂的任何东西,&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBglKKM.html" rel="bookmark" class="title">神舟电脑平板电脑产品灵雅T10已于日前正式上市</a>
					<div>
						灵雅T10搭载Android2.2系统,采用英伟达Tegra 250处理器,并内置8G Micro-SD卡.WiFi无线模块.蓝牙.130万像素摄像头等.3C认证信息显示,神舟平板电脑由浩鑫信息科技( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60oXgz.html" rel="bookmark" class="title">中国互联网网络信息中心域名争议细则</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;      第一条 为了保证域名争议解决程序的公正性.方便性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBL1az.html" rel="bookmark" class="title">eclipse在线安装aptana报错了</a>
					<div>
						问题描述 eclipse在线安装aptana报错了 解决方案 Eclipse在线安装Aptana.eclipse 报错了Aptana/Spket在Eclipse3.4下在线安装 解决方案二: 把det ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkRA0M.html" rel="bookmark" class="title">NVIDIA与英特尔在过去两年，两家公司争斗不断</a>
					<div>
						全球第一大独立显卡供应商.华裔企业NVIDIA将在中国传统节日春节将至时收到一个来自于处理器巨头英特尔的硕大&quot;红包&quot;,在过去两年,两家公司争斗不断.北京时间昨天凌晨,英特尔宣布,为 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
